//Ultraschallsensoren trigger
int trigger1 = 12; //links
int trigger2 = 11; //mitte
int trigger3 = 9;  //rechts
//Ultraschallsensoren echo
int echo1 = 13; //links
int echo2 = 10; //mitte
int echo3 = 8;  //rechts
//Ultraschall Empfaenger dauer
long dauer1 = 0; //links
long dauer2 = 0; //mitte
long dauer3 = 0; //rechts
//Entfernung zum Hinderniss Ultraschallsensor
long entfernung1 = 0; //links
long entfernung2 = 0; //mitte
long entfernung3 = 0; //rechts
//Stepper Links
int enableL = 7;
int stepL = 6;
int richtungL = 5;
//Stepper Rechts
int enableR = 4;
int stepR = 3;
int richtungR = 2;

//Schrittanzahl Stepper
int stepCounter;
int steps = 500;

//Infrarot Empfaenger
int IRpin = A1;
int IRwert = 0;

void setup() {
  Serial.begin(9600);                     
    //Ultraschallsensoren
  pinMode(trigger1, OUTPUT);              
  pinMode(echo1, INPUT);   
  pinMode(trigger2, OUTPUT);              
  pinMode(echo2, INPUT);  
  pinMode(trigger3, OUTPUT);              
  pinMode(echo3, INPUT);     
   //Stepper Links
  pinMode(enableL, OUTPUT); // Enable
  pinMode(stepL, OUTPUT); // Step
  pinMode(richtungL, OUTPUT); // Richtung
   //Stepper Rechts
  pinMode(enableR, OUTPUT); // Enable
  pinMode(stepR, OUTPUT); // Step
  pinMode(richtungR, OUTPUT); // Richtung
 
  digitalWrite(7,LOW);
  digitalWrite(4,LOW);

  //IR Empfaenger
  pinMode(IRpin, INPUT);
}

void loop() {

    //IR Empfaenger auslesen
  IRwert = analogRead(IRpin);
  Serial.println(IRwert);
 
    //Ultraschallsensor 1 (Links)
    //Anti Rauschstörung für Ultraschallsensoren
  digitalWrite(trigger1, LOW); 
  delay(5);   
    //Sendet Ultraschallsignal
  digitalWrite(trigger1, HIGH);
  delay(10);
    //Abschließen des Sendens
  digitalWrite(trigger1, LOW);
    //Gemessene Zeit
  dauer1 = pulseIn(echo1, HIGH);
  
    //Ultraschallsensor 2 (Mitte)
    //Anti Rauschstörung für Ultraschallsensoren
  digitalWrite(trigger2, LOW);
  delay(5);
    //Sendet Ultraschallsignal
  digitalWrite(trigger2, HIGH);
  delay(10);
    //Abschließen des Sendens
  digitalWrite(trigger2, LOW); 
    //Gemessene Zeit
  dauer2 = pulseIn(echo2, HIGH);

    //Ultraschallsensor 3 (Rechts)
    //Anti Rauschstörung für Ultraschallsensoren
  digitalWrite(trigger3, LOW);
  delay(5);
    //Sendet Ultraschallsignal
  digitalWrite(trigger3, HIGH);     
  delay(10);  
    //Abschließen des Sendens
  digitalWrite(trigger3, LOW);                   
    //Gemessene Zeit                             
  dauer3 = pulseIn(echo3, HIGH);     
      
    // Die Zeit in den Wegumrechnen (in cm)
  entfernung1 = ((dauer1)/2) / 29.1; 
  entfernung2 = ((dauer2)/2) / 29.1;
  entfernung3 = ((dauer3)/2) / 29.1;  

          //Ausgabe
  Serial.print(entfernung1); 
  Serial.println(" cm (Entfernung Sensor 1)");
  Serial.print(entfernung2); 
  Serial.println(" cm (Entfernung Sensor 2)");
  Serial.print(entfernung3); 
  Serial.println(" cm (Entfernung Sensor 3)");
  
  //Richtungsänderungen wenn zu nah am Hindernis
  if (entfernung1 < 30 && entfernung1 != 0)
  {
    for(stepCounter = 0; stepCounter < steps; ++stepCounter)
    {
      // Drehen im Kreis
      digitalWrite(richtungL,LOW); 
      digitalWrite(richtungR, HIGH);
 
      digitalWrite(stepL,LOW);
      digitalWrite(stepR, LOW);
      
      delayMicroseconds(1000);
      
      digitalWrite(stepL,HIGH);
      digitalWrite(stepR, HIGH);
      
      delayMicroseconds(1000);
    }
  }
  if (entfernung2 < 30 && entfernung2 != 0)
  {
    for(stepCounter = 0; stepCounter < steps; ++stepCounter)
    {
      // Rueckwerts
      digitalWrite(richtungL,HIGH); 
      digitalWrite(richtungR, HIGH);
 
      digitalWrite(stepL,LOW);
      digitalWrite(stepR, LOW);
      
      delayMicroseconds(1000);
      
      digitalWrite(stepL,HIGH);
      digitalWrite(stepR, HIGH);
      
      delayMicroseconds(1000);
    }
  }

    if (entfernung3 < 30 && entfernung3 != 0)
  {
    for(stepCounter = 0; stepCounter < steps; ++stepCounter)
    {
      // Drehen im Kreis
      digitalWrite(richtungL,HIGH); 
      digitalWrite(richtungR, LOW);
 
      digitalWrite(stepL,LOW);
      digitalWrite(stepR, LOW);
      
      delayMicroseconds(1000);
      
      digitalWrite(stepL,HIGH);
      digitalWrite(stepR, HIGH);
      
      delayMicroseconds(1000);
    }
    
  }
  delay(500);                            
 
}
